// PluginSettings.cpp: implementation of the CPluginSettings class.
//
//////////////////////////////////////////////////////////////////////

#include "PluginSettings.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPluginSettings::CPluginSettings()
{

}

CPluginSettings::~CPluginSettings()
{

}

bool CPluginSettings::SetRegKey(const char *name, const char * val)
{
        HKEY hKey=NULL;
        DWORD dwDisposition;
        if(!RegCreateKeyEx(HKEY_CURRENT_USER,m_RootKey,0,NULL,NULL,KEY_ALL_ACCESS,NULL,&hKey,&dwDisposition)==ERROR_SUCCESS||!hKey)
                return false;
        
        if(RegSetValueEx(hKey,name,0,REG_SZ,(BYTE*)val,strlen(val)))
                return false;
        return true;
}
bool CPluginSettings::GetRegKey(const char *name, char * val)
{
        val[0]='\0';
        HKEY hKey=NULL;
        if(!RegOpenKey(HKEY_CURRENT_USER,m_RootKey,&hKey)==ERROR_SUCCESS||!hKey)
                return false;
        //MessageBox(NULL,name,g_Opt.RegKey,0);
        DWORD dwSize = MAX_PATH,dwType=REG_SZ;
        if(!RegQueryValueEx(hKey,name,0,&dwType,(BYTE*)val,&dwSize)==ERROR_SUCCESS)
                return false;
        return true;
}

bool CPluginSettings::SetValue(const char *key,BOOL &bVar,BOOL bVal)
{
        char buf[2];
        if(bVal)
            strcpy(buf,"1");
        else
            strcpy(buf,"0");
		bVar=bVal;
        return SetRegKey(key,buf);
}
bool CPluginSettings::GetValue(const char *key,BOOL &bVar,BOOL bDefault)
{
        char buf[20];
        if(!GetRegKey(key,buf))
        {
            if(bDefault)
            {
                SetRegKey(key,"1");
                bVar=TRUE;
            }
            else
            {
                if(!SetRegKey(key,"0"))
					return false;
                bVar=FALSE;
            }
        }
        else
        {
            bVar=FALSE;
            if(!strcmp(buf,"1"))
                bVar=TRUE;
        }
		return true;
}
char * CPluginSettings::GetRootKey()
{
	return m_RootKey;
}
bool CPluginSettings::SetRootKey(const char* root)
{
	if(strlen(root)>MAX_PATH)
		return false;
	strcpy(m_RootKey,root);
		return true;
}

bool CPluginSettings::GetValue(const char *key, char *pVar, const char *cpDefault)
{
	if(!GetRegKey(key,pVar))
	{
		//if(!SetRegKey(key,cpDefault))
			return false;

		strcpy(pVar,cpDefault);
	}
	return true;
}

bool CPluginSettings::SetValue(const char *key, char *pVar, const char *cpVal)
{
	if(!SetRegKey(key,cpVal))
		return false;
	if(!pVar)
		return true;
	strcpy(pVar,cpVal);
	return true;
}

bool CPluginSettings::SetValue(const char *key, long &lVar, long lVal)
{
	char buf[30];
	sprintf(buf,"%d",lVal);
	if(!SetRegKey(key,buf))
		return false;
	lVar=lVar;
	return true;
}

bool CPluginSettings::GetValue(const char *key, long &lVar, long lDefault)
{
	char buf[30];

	if(!GetRegKey(key,buf))
	{
		sprintf(buf,"%d",lDefault);
		if(!SetRegKey(key,buf))
		return false;
		lVar=lDefault;
		return true;
	}
	else
		lVar=atoi(buf);
	return true;
}
