#define _FAR_NO_NAMELESS_UNIONS
#include "farkeys.hpp"
#include "plugin.hpp"
#include "stdio.h"
#include "PluginSettings.h"
#include <string>
#include <vector>
using namespace std;

#define DLG_HEIGHT 3
#define DLG_WIDTH g_Opt.DlgWidth


/// ************************************************************************
///      
/// ************************************************************************

#define SET_FILT      "%%%%panelfilter=\"%s\"; CtrlI " \
                      "F4 $if(Dialog) $if(Dlg.getValue(3,0)==\"&_panelfilter_\") Esc Del Enter $else Esc $end $end "\
                      "Ins \"&_panelfilter_\" Tab "\
					  "$IF(dlg.getValue(5,0)==0) Space $END "\
					  "Tab $text %%%%panelfilter Enter Add %s $if(menu) Enter $end "


//------------------------------
/**
        
*/
const char MCR_SETFILTER[]= "Esc "\
					  SET_FILT
                      "F11 %s ";
//------------------------------
/**
          
*/
const char MCR_DELFILTER[]="Esc CtrlI " \
                      "F4 $if(dialog) $if(Dlg.getValue(3,0)==\"&_panelfilter_\") Esc Del Enter Esc $else Esc Enter $end  $else Esc $end F11 %s";
//------------------------------
/**
       
*/
const char MCR_SETCMDLINE[]= SET_FILT;
//------------------------------
/**
          
*/
const char MCR_DELCMDLINE[]="CtrlI " \
                      "F4 $if(Dialog) $if(Dlg.getValue(3,0)==\"&_panelfilter_\") Esc Del Enter Esc $else Esc Esc $end $else Esc $end";
                      

const char MCR_COPYFILTER[]=" Tab "\
						   "CtrlI F4 $if(Dlg.getValue(3,0)==\"&_panelfilter_\") Esc Add Enter $else Esc Esc $end ";

/// ************************************************************************
///     
/// ************************************************************************

static struct PluginStartupInfo Info;
static struct FarStandardFunctions FSF;
/**
      
*/
typedef struct OPTIONS
{
	BOOL bDirFilter;				///<    ?
	BOOL bRight;					///<  ?
    int DlgWidth;                   ///<  
	char UserTextLeft[512];			///<     
	char UserTextRight[512];		///<     
	char CustomFormat[100];			///<   
    char HistoryName[50];           ///<  ,   
    char UserText[512];             ///< ,  
 //   char Filter[512];             ///<  
    char DefaultFilterFormat[100];  ///<    
    bool bOldFAR;                   ///< true -    Far
    BOOL bUserRun;                  ///< True,    
	long bRememberFilter;			///< True,        ,     
	BOOL bTabFilter;				///< True,     
	BOOL bEscDelFilter;
	char MacroSetFilter[1024];
	char MacroDelFilter[1024];
	char MacroSetFilterCmd[1024];
	char MacroDelFilterCmd[1024];
	char MacroCopyFilter[1024];
    char Hotkey[2];                 ///<   


}OPTIONS;

OPTIONS g_Opt;

//------------
/**
     
*/
typedef struct InitDialogItem {
    unsigned char Type;             ///<  
    unsigned char X1, Y1, X2, Y2;   ///< 
    int Data;                       ///<  
    unsigned int SelectedDefault;   ///<  >0 -    
    unsigned int Flags;             ///< 
    }InitDialogItem ;
//------------
/**
      lng
*/
enum CompareLng
{
    MMenuStr,	///<   
    MOldFar,	///<   Far  
    MNoHotkey,	///<      
    MTitle,		///<  
	MCfgTitle,	///<     Settings.cfg
	MKeyMask,
	MKeyAttr,
	MKeyDir,
/// -- ,    lng
    MFilter,
};

/// ************************************************************************
///       FAR
/// ************************************************************************
//---------------------------------------------------------------------
static const char *GetMsg(int  MsgId) {
  return Info.GetMsg(Info.ModuleNumber, MsgId);
}
//---------------------------------------------------------------------
void WINAPI _export SetStartupInfo(const struct PluginStartupInfo *Info) 
{
    ::Info = *Info;
    if (Info->StructSize >= sizeof(struct PluginStartupInfo))
    {
        FSF = *Info->FSF;
        g_Opt.bOldFAR = false;
    }
    else
        g_Opt.bOldFAR = true;
    g_Opt.bUserRun = true;
}
//---------------------------------------------------------------------
void WINAPI _export GetPluginInfo(struct PluginInfo *Info) 
{
    Info->StructSize = sizeof(*Info);
    Info->Flags = 0;
    Info->DiskMenuStringsNumber = 0;
    static const char *PluginMenuStrings[1];
    PluginMenuStrings[0]=GetMsg(MMenuStr);

    Info->PluginMenuStrings=PluginMenuStrings;

    Info->PluginMenuStringsNumber = 1;
    Info->PluginConfigStringsNumber = 0;
    Info->CommandPrefix="panfilter";
    Info->Flags = 0;
}
/// ************************************************************************
///      
/// ************************************************************************

//---------------------------------------------------------------------
/**
        str   find  replacement
    \param ,    
    \param   
    \param   
*/
void ReplaceAll(std::string &str,std::string find,std::string replacement)
{
    long l=str.length()-1;
    while(l>-1)
    {
        l=str.rfind(find,l);
        if(l==-1)
            break;
        str=str.replace(l,find.length(),replacement);
        --l;
    }
}

//---------------------------------------------------------------------
/**
       
    \param macros  
*/
BOOL RunMacro(const char* macros)
{
       ActlKeyMacro mac;
       mac.Command=MCMD_POSTMACROSTRING;
       mac.Param.PlainText.SequenceText=new char[strlen(macros)+1];
       mac.Param.PlainText.Flags=KSFLAGS_DISABLEOUTPUT;
       strcpy(mac.Param.PlainText.SequenceText,macros);
       int ret=Info.AdvControl(Info.ModuleNumber,ACTL_KEYMACRO,&mac);
       delete mac.Param.PlainText.SequenceText;
       return ret;     
}
//---------------------------------------------------------------------
/**
        Far
    \param str   
*/
int FarMsg(const char * str,const char* HelpTopic=NULL)
{
    char * msg = new char [strlen(str)+strlen(GetMsg(MMenuStr))+6];
    strcpy(msg,GetMsg(MMenuStr));
    strcat(msg,"\n");
    strcat(msg,str);
    DWORD Flags=FMSG_ALLINONE|FMSG_MB_OK|FMSG_LEFTALIGN;
    return Info.Message(Info.ModuleNumber,
                        Flags,
                        HelpTopic,
                        (const char * const *)msg,
                        2,
                        0
                       );
}
//---------------------------------------------------------------------
/**
        
*/
void ReadPluginSettings()
{
    ///  
    char sKey[MAX_PATH];
    CPluginSettings set;
    strcpy(sKey,Info.RootKey);
    strcat(sKey,"\\panelfilter");
    set.SetRootKey(sKey);
    set.GetValue("HistoryName",g_Opt.HistoryName,"");
    set.GetValue("DlgWidth",(long &)g_Opt.DlgWidth,70);
    set.GetValue("DefaultFilterFormat",g_Opt.DefaultFilterFormat,"*%s*");
	set.GetValue("RememberLastFilter",(long &)g_Opt.bRememberFilter,0);
	set.GetValue("CustomFilterFormat",g_Opt.CustomFormat,"");
	set.GetValue("MacroSetFilter",(char*)g_Opt.MacroSetFilter,MCR_SETFILTER);
	set.GetValue("MacroDelFilter",(char*)g_Opt.MacroDelFilter,MCR_DELFILTER);
	set.GetValue("MacroCopyFilter",(char*)g_Opt.MacroCopyFilter,MCR_COPYFILTER);
	set.GetValue("MacroSetFilterCmd",(char*)g_Opt.MacroSetFilterCmd,MCR_SETCMDLINE);
	set.GetValue("MacroDelFilterCmd",(char*)g_Opt.MacroDelFilterCmd,MCR_DELCMDLINE);
	set.GetValue("DirFilter",(BOOL &)g_Opt.bDirFilter,TRUE);
	set.GetValue("TabFilter",(BOOL &)g_Opt.bTabFilter,FALSE);
	set.GetValue("EscDelFilter",(BOOL &)g_Opt.bEscDelFilter,FALSE);
	PanelInfo inf;
	Info.Control(INVALID_HANDLE_VALUE,FCTL_GETPANELSHORTINFO,&inf);
	if(inf.PanelRect.left==0)
		g_Opt.bRight = 0;
	else
		g_Opt.bRight = 1;
//   
    set.GetValue("Hotkey",(char*)g_Opt.Hotkey,"");
    if(!strcmp(g_Opt.Hotkey,"")) //     
    {
        strcpy(sKey,Info.RootKey);
        char * s1 = strstr(sKey,"\\Plugins");
        if(s1)
        {
            s1[0]=0;
        }
        strcat(sKey,"\\PluginHotkeys\\Plugins/panelfilter/panelfilter.dll");
        set.SetRootKey(sKey);
        set.GetValue("Hotkey",g_Opt.Hotkey,"");
    }
}

//---------------------------------------------------------------------
/**
      . 
    \param true -     
*/
void ExecFilter(bool bCmd)
{
    char buf[1024];
    char tmp[1024];
    if(!strcmp(g_Opt.UserText,""))
    {
        sprintf(buf,bCmd?g_Opt.MacroDelFilterCmd:g_Opt.MacroDelFilter,g_Opt.Hotkey);
        RunMacro(buf);
        return;
    }
    std::string sMacro(g_Opt.UserText);
    ReplaceAll(sMacro,"\"","\\\"");
    ReplaceAll(sMacro,"\\","\\\\");
    
	const char * drmacro = g_Opt.bDirFilter?" CtrlF ":" ";
	if(strcmp(g_Opt.CustomFormat,""))
	{
        sprintf(tmp,g_Opt.CustomFormat,sMacro.c_str());
        sprintf(buf,bCmd?g_Opt.MacroSetFilterCmd:g_Opt.MacroSetFilter,tmp,drmacro,g_Opt.Hotkey);
	}
    else if(sMacro.find('*')==-1&&sMacro.find('?')==-1)
    {
        sprintf(tmp,g_Opt.DefaultFilterFormat,sMacro.c_str());
        sprintf(buf,bCmd?g_Opt.MacroSetFilterCmd:g_Opt.MacroSetFilter,tmp,drmacro,g_Opt.Hotkey);
    }
    else
    {
        sprintf(buf,bCmd?g_Opt.MacroSetFilterCmd:g_Opt.MacroSetFilter,sMacro.c_str(),drmacro,g_Opt.Hotkey);
    }
//        std::string sMacro(dat->Data.Data);
    RunMacro(buf);
}

//---------------------------------------------------------------------
/**
      -      
    \param key  
*/
void PressKey(long key)
{
    KeySequence s;
    s.Sequence = new DWORD[1];
    s.Sequence[0] = key;
    s.Count = 1;
    s.Flags = 0;
    Info.AdvControl(Info.ModuleNumber,ACTL_POSTKEYSEQUENCE,(void*)&s);
    delete s.Sequence;
}

//---------------------------------------------------------------------
/**
     -  
    \param hDlg -   
    \param msg - ID 
    \param param1 -    
    \param param2 -    
*/
long DialogProc(HANDLE hDlg, int msg, int param1,long param2)
{
    if(msg==DN_EDITCHANGE)
    {
		FarDialogItem *dat = (FarDialogItem*)param2;
		strcpy(g_Opt.UserText,dat->Data.Data);
		strcpy(g_Opt.bRight?g_Opt.UserTextRight:g_Opt.UserTextLeft,g_Opt.UserText);
		ExecFilter(false);
		g_Opt.bUserRun = false;
        Info.SendDlgMessage(hDlg,DM_CLOSE,0,0);
        return TRUE;

    }
    if(msg==DN_KEY)
    {
		struct FarDialogItem DialogItem;
		Info.SendDlgMessage(hDlg,DM_GETDLGITEM,1,(long)&DialogItem);
		strcpy(g_Opt.UserText,DialogItem.Data.Data);
		char mcr[100];
		if(param2==KEY_TAB/*&&g_Opt.bTabFilter*/)
		{
			sprintf(mcr,"Tab F11 %s",g_Opt.Hotkey);
			RunMacro(mcr);
			//RunMacro(MacroCopyFilter);
			//PressKey(param2);
			Info.SendDlgMessage(hDlg,DM_CLOSE,-1,0);

			return TRUE;
		}
		else if(param2==KEY_F8)
		{
			RunMacro("CtrlY");
		}
		else if(param2==KEY_F5)
		{
			strcpy(g_Opt.bRight?g_Opt.UserTextLeft:g_Opt.UserTextRight,g_Opt.UserText);
			RunMacro("Tab");
			ExecFilter(true);
			sprintf(mcr,"Tab F11 %s",g_Opt.Hotkey);
			RunMacro(mcr);
			Info.SendDlgMessage(hDlg,DM_CLOSE,-1,0);
			return TRUE;
			//RunMacro(g_Opt.MacroDelFilter)
		}
		else if(param2==KEY_F6)
		{
			strcpy(g_Opt.bRight?g_Opt.UserTextLeft:g_Opt.UserTextRight,g_Opt.UserText);
			strcpy(g_Opt.UserText,"");
			RunMacro("Esc");
			ExecFilter(true);
			strcpy(g_Opt.bRight?g_Opt.UserTextRight:g_Opt.UserTextLeft,"");
			strcpy(g_Opt.UserText,g_Opt.bRight?g_Opt.UserTextLeft:g_Opt.UserTextRight);
			RunMacro("Tab");
			ExecFilter(true);
			sprintf(mcr,"Tab F11 %s",g_Opt.Hotkey);
			RunMacro(mcr);
			//Info.SendDlgMessage(hDlg,DM_CLOSE,-1,0);
			return TRUE;
			//RunMacro(g_Opt.MacroDelFilter)
		}
		else if(param2==KEY_ESC&&g_Opt.bEscDelFilter)
		{
			strcpy(g_Opt.UserText,"");
			Info.SendDlgMessage(hDlg,DM_CLOSE,1,0);
			ExecFilter(true);
			return TRUE;
		}
		else if(param2==KEY_ENTER)
		{

			strcpy(g_Opt.bRight?g_Opt.UserTextRight:g_Opt.UserTextLeft,g_Opt.UserText);
			ExecFilter(true);
			Info.SendDlgMessage(hDlg,DM_CLOSE,1,0);
			return TRUE;
		}
        else if(/*param2==KEY_ENTER||*/
           param2==KEY_PGDN||
           param2==KEY_PGUP||
           param2==KEY_DOWN||
           param2==KEY_UP||
           param2==KEY_F3||
           param2==KEY_F4||
           param2==KEY_CTRLPGDN||
           param2==KEY_CTRLPGUP||
		   param2==KEY_SHIFTF4
            )   
        {
            PressKey(param2);    
            Info.SendDlgMessage(hDlg,DM_CLOSE,0,0);
            return TRUE;
        }
		else if(param2==KEY_ALTF4)
		{
			char buf[MAX_PATH];
			strcpy(buf,Info.ModuleName);
			char * b=strrchr(buf,'\\');
			if(b)
			{
				b[0]=0;
			}
			strcat(buf,"\\Settings.reg");
			if(Info.Editor(buf,GetMsg(MCfgTitle),0,0,-1,-1,0,1,1)==EEC_MODIFIED)
			{
				char cmd[1024];
				strcpy(cmd,"regedit /s \"");
				strcat(cmd,buf);
				strcat(cmd,"\"");
				WinExec(cmd,SW_HIDE);
				//ReadPluginSettings();
			}
			g_Opt.bUserRun = false;
            Info.SendDlgMessage(hDlg,DM_CLOSE,-12,0);
			return TRUE;
		}
    }
    return Info.DefDlgProc(hDlg,msg,param1,param2);
}


//---------------------------------------------------------------------
//   	
//---------------------------------------------------------------------
HANDLE WINAPI _export OpenPlugin(int OpenFrom, int Item) 
{
    
    if(g_Opt.bOldFAR)
    {
        FarMsg(GetMsg(MOldFar));
        return INVALID_HANDLE_VALUE;
    }
    if(g_Opt.bUserRun)
        ReadPluginSettings();
    if(!strcmp(g_Opt.Hotkey,""))
    {
        FarMsg(GetMsg(MNoHotkey),"NoHotKey");
        return INVALID_HANDLE_VALUE;
    }
    if(OpenFrom == OPEN_COMMANDLINE)
    {
        strcpy(g_Opt.UserText,(char*) Item);
        ExecFilter(true);
        return INVALID_HANDLE_VALUE;
    }
    char buf[512];
  InitDialogItem InitItems[] = {
/*0*/{ DI_DOUBLEBOX, 0,  0, DLG_WIDTH-1, 2, MTitle,    0, NULL },
/*1*/{ DI_EDIT,      2,  1, DLG_WIDTH-3, 1, MFilter,   1, DIF_EDITOR/*|DIF_MANUALADDHISTORY0*/ },
  };
    static struct FarDialogItem DialogItems[sizeof(InitItems) / sizeof(InitItems[0])];
    for (int i = sizeof(InitItems) / sizeof(InitItems[0]) - 1; i >= 0; i--) {
        DialogItems[i].Type  = InitItems[i].Type;
        DialogItems[i].X1    = InitItems[i].X1;
        DialogItems[i].Y1    = InitItems[i].Y1;
        DialogItems[i].X2    = InitItems[i].X2;
        DialogItems[i].Y2    = InitItems[i].Y2;
        DialogItems[i].Focus = FALSE;
        DialogItems[i].Flags = InitItems[i].Flags;
        DialogItems[i].Param.Selected = InitItems[i].SelectedDefault;
            switch(InitItems[i].Data)
            {
                case MFilter:
					//if(g_Opt.bRememberFilter)
						
                    if(strcmp(g_Opt.HistoryName,""))
                    {
                        DialogItems[i].Param.History=g_Opt.HistoryName;
                        DialogItems[i].Flags|=DIF_HISTORY;
                    }
                    if(!g_Opt.bUserRun||g_Opt.bRememberFilter)
					{
                        strcpy(buf,g_Opt.bRight?g_Opt.UserTextRight:g_Opt.UserTextLeft);
						if(g_Opt.bUserRun&&g_Opt.bRememberFilter==2)
							DialogItems[i].Flags|=DIF_SELECTONENTRY;
					}
                    else
                        strcpy(buf,"");
                    g_Opt.bUserRun = true;
                    break;
                default:
                    strcpy(buf,GetMsg(InitItems[i].Data));
            }
           strcpy(DialogItems[i].Data.Data,buf);
    }
    CONSOLE_SCREEN_BUFFER_INFO inf;
    GetConsoleScreenBufferInfo(GetStdHandle(STD_OUTPUT_HANDLE),&inf);
    int div = ((COORD)inf.dwSize).Y;
	if(strcmp(g_Opt.HistoryName,""))
		div -=5;
    int ret=Info.DialogEx(Info.ModuleNumber,
                        -1,div-3,DLG_WIDTH,div-1,
                        "Dlg",
                        DialogItems,
                        sizeof(InitItems) / sizeof(InitItems[0]),
                        0,
                        FDLG_SMALLDIALOG,
                        DialogProc,
                        0
                        );
	if(ret==-12) //   
	{
		//Info.AdvControl(Info.ModuleNumber,ECTL_REDRAW,0);
		Info.Control(INVALID_HANDLE_VALUE,FCTL_REDRAWPANEL,0);
		Info.Control(INVALID_HANDLE_VALUE,FCTL_REDRAWANOTHERPANEL,0);
		ReadPluginSettings();
		return OpenPlugin(OpenFrom,Item);
	}
    return INVALID_HANDLE_VALUE;
}
